#include "4uhv.h"
// cumbia
#include <cumbiapool.h>
#include <cuserviceprovider.h>
#include <cumacros.h>
#include <quapps.h>
// cumbia

#include "ui_4uhv.h"
#include "channel.h"
#include <tango.h>
#include <QMessageBox>
#include <QGridLayout>
// #include <TPushButton>
#include <qubutton.h>//	TPushButton is mapped to QuButton	//	 ## added by qumbiaprojectwizard
#include <QGroupBox>
#include <QtDebug>
#include <quwatcher.h>

FourUHV::FourUHV(CumbiaPool *cumbia_pool, QWidget *parent) :
    QWidget(parent) {

    // cumbia
    CuModuleLoader mloader(cumbia_pool, &m_ctrl_factory_pool, &m_log_impl);
    cu_pool = cumbia_pool;
    ui = new Ui::FourUHV;
    ui->setupUi(this, cu_pool, m_ctrl_factory_pool);

    // mloader.modules() to get the list of loaded modules
    // cumbia
    if(qApp->arguments().size() > 1) {
        m_dev = qApp->arguments().at(1);
        Qu1TWatcher *spw = new Qu1TWatcher(this, cu_pool, m_ctrl_factory_pool);
        connect(spw, SIGNAL(newData(const CuData&)), this, SLOT(onPsListReady(const CuData& )));
        spw->setSource("tango://#vacuum#power_supply");
    }
}

FourUHV::~FourUHV() {
    delete ui;
}

void FourUHV::applyThresholdClicked()
{
    const QString& onam = sender()->objectName();
    if(onam.startsWith("tpbApplyThHigh"))
        findChild<QGroupBox *>("");
}

void FourUHV::onPsListReady(const CuData &da) {
    if(da.B("err")) {
    }
    else {
        std::vector<std::string> list = da["value"].toStringVector();
        for(size_t i = 0; i < list.size(); i++) {
            QStringList parts = QString::fromStdString(list.at(i)).split(":");
            if(parts.size() >= 3 && m_dev == parts.first()) {
                for(int ch = 1; ch < parts.size(); ch++)
                    if(parts[ch].compare("none", Qt::CaseInsensitive) != 0)
                        m_chSensorMap[ch] = parts[ch];
            }
        }

        int r = 0, c = 0;
        QGridLayout *glo = new QGridLayout(ui->contentsWidget);
        foreach(int ch, m_chSensorMap.keys()) {
            Channel *channel = new Channel(ui->contentsWidget, cu_pool, m_ctrl_factory_pool);
            channel->findChild<QLabel*>("lChannel")->setText(QString("Channel %1 - %2")
                                                             .arg(ch).arg(m_chSensorMap[ch].section('/', -1, -1)));
            foreach(QWidget *w, channel->findChildren<QWidget *>()) {
                if(w->metaObject()->indexOfProperty("source") > -1) {
                    const QString& s = w->property("point").toString();
                    if(s.contains("%1")) w->setProperty("source",  QString(s).arg(ch));
                }
                if(w->property("target").isValid() || w->objectName().contains(QRegularExpression("pbFix\\dk"))) {
                    const QString& t = w->property("point").toString();
                    printf("FourUHV::onPsListReady: %s point is %s \n",
                           qstoc(w->objectName()), qstoc(t));
                    if(t.contains("%1")) {
                        w->setProperty("channel", ch);
                        w->setProperty("target", QString(t).arg(ch));
                    }
                }
            }
            channel->findChild<QGroupBox *>("gbHighTh")->setHidden(true);
            channel->findChild<QGroupBox *>("gbLowTh")->setHidden(true);
            glo->addWidget(channel, r, c % 2, 1, 1);
            if(c == 1) {
                c = 0; r++;
            }
            else
                c++;

            foreach(QGroupBox *gb, channel->findChild<QTabWidget *>()->widget(1)->findChildren<QGroupBox *>())
                connect(gb->findChild<QuButton *>(), SIGNAL(clicked()), this, SLOT(applyThresholdClicked()));
        }
    }
}


