#include "channel.h"
#include "ui_channel.h"
#include <quwriter.h>

Channel::Channel(QWidget *parent, CumbiaPool *cu_p, const CuControlsFactoryPool &fp) :
    QWidget(parent), cu_pool(cu_p), m_ctrl_fpool(fp) {
    ui = new Ui::Channel;
    ui->setupUi(this, cu_p, fp);
    connect(ui->pbFix3k, SIGNAL(clicked()), this, SLOT(onPbFixClicked()));
    connect(ui->pbFix5k, SIGNAL(clicked()), this, SLOT(onPbFixClicked()));
    connect(ui->pbFix7k, SIGNAL(clicked()), this, SLOT(onPbFixClicked()));
}

Channel::~Channel()
{
    delete ui;
}

void Channel::onPbFixClicked() {
    const QString& t0 = QString("$1/Fixed%1(1)").arg(sender()->property("channel").toInt());
    const QString& t1 = sender()->property("target").toString();
    foreach(const QString& t, QStringList() << t0 << t1) {
        QuWriter *w = new QuWriter(this, cu_pool, m_ctrl_fpool);
        w->setAutoDestroy(true);
        w->setTarget(t);
        w->execute();
    }
}
